<script>
import { SlpPlayIcon, SolutionsVideoModal } from '../solutions/index.vue';
import { UseLiteYouTube } from '~/mixins';
export default {
  components: {
    SolutionsVideoModal,
    SlpPlayIcon,
  },
  mixins: [UseLiteYouTube],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
};
</script>

<template>
  <div class="customers-gradient">
    <SlpContainer>
      <div class="customers-hero">
        <div class="header">
          <SlpTypography variant="heading5-bold" tag="h2" class="slp-mb-24">
            {{ data.description }}
          </SlpTypography>
          <SlpTypography variant="heading1-bold" tag="h1">
            {{ data.title }}
          </SlpTypography>
          <SlpButton
            variant="primary"
            :data-ga-name="data.primaryCta.fields.dataGaName"
            :data-ga-location="data.primaryCta.fields.dataGaLocation"
            :href="data.primaryCta.fields.externalUrl"
          >
            {{ data.primaryCta.fields.text }}
          </SlpButton>
        </div>
        <div class="video">
          <div class="image__container" @click="openModal">
            <img
              :src="data.video.fields.thumbnail.fields.image.fields.file.url"
              :alt="data.video.title"
              preload
            />
            <div class="image__container--play">
              <SlpPlayIcon />
            </div>
          </div>
        </div>
      </div>
    </SlpContainer>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <lite-youtube
          :videoid="getYTVideoId(data.video.fields.url)"
          class="video-iframe"
          title="YouTube video player"
        ></lite-youtube>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.video-iframe {
  aspect-ratio: 16 / 9;
  width: 600px;
  height: 337.5px;

  @media (max-width: $breakpoint-md) {
    width: 300px;
    height: 168.75px;
  }
}
.customers-gradient {
  background: url('/nuxt-images/customers/gradient.png');
  margin-bottom: 160px;
  background-repeat: no-repeat;
  background-size: 100% 100%;
  @media (max-width: $breakpoint-md) {
    margin-bottom: 64px;
  }
}

.customers-hero {
  padding-top: 115px;
  display: flex;
  align-items: center;
  gap: 64px;
  @media (max-width: $breakpoint-md) {
    padding-top: 64px;
    flex-direction: column;
  }
  .header {
    margin-bottom: 86px;
    @media (max-width: $breakpoint-md) {
      margin-bottom: 32px;
    }
    & :last-child {
      margin-top: $spacing-16;
    }
  }
  .metrics {
    display: grid;
    grid-template-columns: 1fr 1fr;
    @media (max-width: $breakpoint-lg) {
      grid-template-columns: 1fr;
    }
    .metric {
      text-align: center;
      @media (max-width: $breakpoint-md) {
        border-top: 1px solid #e3d6ff;
        padding: $spacing-24 0;
        &:last-child {
          border-bottom: 1px solid #e3d6ff;
        }
      }
      @media (min-width: $breakpoint-md) {
        border-left: 1px solid #e3d6ff;
        &:last-child {
          border-right: 1px solid #e3d6ff;
        }
      }
    }
  }
}

.image__container {
  position: relative;

  cursor: pointer;
  &:hover {
    .image__container--play {
      opacity: 1;
    }
  }

  &--play {
    position: absolute;
    top: 40%;
    right: 45%;
    opacity: 0.75;
    transition: all 0.3s;
  }
  img {
    border-radius: 4px 4px 90px 4px;
    width: 540px;
    min-height: 322px;
    @media (max-width: $breakpoint-md) {
      width: 100%;
      min-height: initial;
    }
    border-bottom: 1px solid $color-surface-200;
  }
}
</style>
